Index: group__usb.html
===================================================================
--- group__usb.html	(revision 1370)
+++ group__usb.html	(revision 1371)
@@ -41,6 +41,9 @@
 <tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__usb.html#g6e101f68856f272f67923c4fb35a99e0">usb_puts</a> (char *s)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Print a string to USB.  <a href="#g6e101f68856f272f67923c4fb35a99e0"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__usb.html#g774d8b902cae279696c53502168ade07">usb_puts_P</a> (PGM_P s)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Print a string from program space to USB.  <a href="#g774d8b902cae279696c53502168ade07"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__usb.html#gcd371dedbff10f0c52dca4b3b7af9e3d">usb_puti</a> (int value)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Print an integer to USB.  <a href="#gcd371dedbff10f0c52dca4b3b7af9e3d"></a><br></td></tr>
@@ -85,7 +88,7 @@
 </dl>
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>the hexadecimal digit in ASCII code, or '?' if the input is invalid. </dd></dl>
 
-<p>Referenced by <a class="el" href="serial_8c-source.html#l00305">usb_puth16()</a>, and <a class="el" href="serial_8c-source.html#l00323">usb_puth8()</a>.</p>
+<p>Referenced by <a class="el" href="serial_8c-source.html#l00328">usb_puth16()</a>, and <a class="el" href="serial_8c-source.html#l00345">usb_puth8()</a>.</p>
 
 </div>
 </div><p>
@@ -112,7 +115,7 @@
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>the first character in the usb buffer</dd></dl>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__usb.html#gddfbdb66f507ffcd08b4496531ed0a3d" title="Initialize the USB.">usb_init</a>, <a class="el" href="group__usb.html#g6b1209b19e7fd2bbedc7407e0218453c" title="Read a character from USB without blocking.">usb_getc_nb</a> </dd></dl>
 
-<p>Referenced by <a class="el" href="serial_8c-source.html#l00048">usb_init()</a>.</p>
+<p>Referenced by <a class="el" href="serial_8c-source.html#l00055">usb_init()</a>.</p>
 
 </div>
 </div><p>
@@ -166,7 +169,7 @@
 Initialize the USB. 
 <p>
 Initializes communication over the USB serial port. This must be called before any other usb function may be used. 
-<p>References <a class="el" href="serial_8c-source.html#l00165">usb_getc()</a>, and <a class="el" href="serial_8c-source.html#l00117">usb_putc()</a>.</p>
+<p>References <a class="el" href="serial_8c-source.html#l00043">usb_fd</a>, <a class="el" href="serial_8c-source.html#l00188">usb_getc()</a>, and <a class="el" href="serial_8c-source.html#l00124">usb_putc()</a>.</p>
 
 <p>Referenced by <a class="el" href="dragonfly__lib_8c-source.html#l00068">dragonfly_init()</a>.</p>
 
@@ -199,7 +202,7 @@
 </dl>
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>0 for success, nonzero for failure </dd></dl>
 
-<p>Referenced by <a class="el" href="serial_8c-source.html#l00048">usb_init()</a>, <a class="el" href="serial_8c-source.html#l00305">usb_puth16()</a>, <a class="el" href="serial_8c-source.html#l00323">usb_puth8()</a>, <a class="el" href="serial_8c-source.html#l00256">usb_puti()</a>, and <a class="el" href="serial_8c-source.html#l00147">usb_puts()</a>.</p>
+<p>Referenced by <a class="el" href="serial_8c-source.html#l00055">usb_init()</a>, <a class="el" href="serial_8c-source.html#l00328">usb_puth16()</a>, <a class="el" href="serial_8c-source.html#l00345">usb_puth8()</a>, <a class="el" href="serial_8c-source.html#l00279">usb_puti()</a>, <a class="el" href="serial_8c-source.html#l00154">usb_puts()</a>, and <a class="el" href="serial_8c-source.html#l00168">usb_puts_P()</a>.</p>
 
 </div>
 </div><p>
@@ -230,7 +233,7 @@
 </dl>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__usb.html#gddfbdb66f507ffcd08b4496531ed0a3d" title="Initialize the USB.">usb_init</a>, <a class="el" href="group__usb.html#gcd371dedbff10f0c52dca4b3b7af9e3d" title="Print an integer to USB.">usb_puti</a>, <a class="el" href="group__usb.html#g6e101f68856f272f67923c4fb35a99e0" title="Print a string to USB.">usb_puts</a>, <a class="el" href="group__usb.html#g21462df541911e0611416e85be6ea34d" title="Print a fixed width hexadecimal representation to USB.">usb_puth8</a>, <a class="el" href="group__usb.html#g94d47853c33da12c71dec155f819cfeb" title="Determine a hexadecimal digit.">hex_digit</a> </dd></dl>
 
-<p>References <a class="el" href="serial_8c-source.html#l00288">hex_digit()</a>, and <a class="el" href="serial_8c-source.html#l00117">usb_putc()</a>.</p>
+<p>References <a class="el" href="serial_8c-source.html#l00311">hex_digit()</a>, and <a class="el" href="serial_8c-source.html#l00124">usb_putc()</a>.</p>
 
 </div>
 </div><p>
@@ -261,7 +264,7 @@
 </dl>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__usb.html#gddfbdb66f507ffcd08b4496531ed0a3d" title="Initialize the USB.">usb_init</a>, <a class="el" href="group__usb.html#gcd371dedbff10f0c52dca4b3b7af9e3d" title="Print an integer to USB.">usb_puti</a>, <a class="el" href="group__usb.html#g6e101f68856f272f67923c4fb35a99e0" title="Print a string to USB.">usb_puts</a>, <a class="el" href="group__usb.html#g8e7e31f1e45721ac032267b13d0f759b" title="Print a fixed width hexadecimal representation to USB.">usb_puth16</a>, <a class="el" href="group__usb.html#g94d47853c33da12c71dec155f819cfeb" title="Determine a hexadecimal digit.">hex_digit</a> </dd></dl>
 
-<p>References <a class="el" href="serial_8c-source.html#l00288">hex_digit()</a>, and <a class="el" href="serial_8c-source.html#l00117">usb_putc()</a>.</p>
+<p>References <a class="el" href="serial_8c-source.html#l00311">hex_digit()</a>, and <a class="el" href="serial_8c-source.html#l00124">usb_putc()</a>.</p>
 
 </div>
 </div><p>
@@ -293,7 +296,7 @@
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>0 if successful, nonzero otherwise</dd></dl>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__usb.html#gddfbdb66f507ffcd08b4496531ed0a3d" title="Initialize the USB.">usb_init</a>, <a class="el" href="group__usb.html#g3ee898cfe59d05c428c56021c2ccf946" title="Print a character to USB.">usb_putc</a> </dd></dl>
 
-<p>References <a class="el" href="serial_8c-source.html#l00117">usb_putc()</a>.</p>
+<p>References <a class="el" href="serial_8c-source.html#l00124">usb_putc()</a>.</p>
 
 </div>
 </div><p>
@@ -324,12 +327,42 @@
 </dl>
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>0 for success, nonzero for failure </dd></dl>
 
-<p>References <a class="el" href="serial_8c-source.html#l00117">usb_putc()</a>.</p>
+<p>References <a class="el" href="serial_8c-source.html#l00124">usb_putc()</a>.</p>
 
 </div>
 </div><p>
+<a class="anchor" name="g774d8b902cae279696c53502168ade07"></a><!-- doxytag: member="serial.h::usb_puts_P" ref="g774d8b902cae279696c53502168ade07" args="(PGM_P s)" -->
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void usb_puts_P           </td>
+          <td>(</td>
+          <td class="paramtype">PGM_P&nbsp;</td>
+          <td class="paramname"> <em>s</em>          </td>
+          <td>&nbsp;)&nbsp;</td>
+          <td width="100%"></td>
+        </tr>
+      </table>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Thu Apr 16 18:33:23 2009 for libdragonfly by&nbsp;
+<div class="memdoc">
+
+<p>
+Print a string from program space to USB. 
+<p>
+Sends a sequence of characters from program space over USB.<p>
+<dl compact><dt><b>Parameters:</b></dt><dd>
+  <table border="0" cellspacing="2" cellpadding="0">
+    <tr><td valign="top"></td><td valign="top"><em>s</em>&nbsp;</td><td>the string to send </td></tr>
+  </table>
+</dl>
+
+<p>References <a class="el" href="serial_8c-source.html#l00124">usb_putc()</a>.</p>
+
+</div>
+</div><p>
+</div>
+<hr size="1"><address style="text-align: right;"><small>Generated on Wed Sep 2 23:20:09 2009 for libdragonfly by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.5 </small></address>
 </body>