Index: trunk/code/projects/test/test_lights.c
===================================================================
--- trunk/code/projects/test/test_lights.c	(revision 1387)
+++ trunk/code/projects/test/test_lights.c	(revision 1388)
@@ -1,23 +1,361 @@
 #include <dragonfly_lib.h>
 
-int testlights(void) {
-    //usb_init();
+
+	
+int test_lights(void) {
+	 int i=0;
+		
+	//usb_init();
     usb_puts("usb turned on\n");
-    delay_ms(1000);
+    delay_ms(1000);	
+	
+/** Test RGB color setting (both orbs) **/
+	for(i=0;i<256;i++){
+		orb_set(i,0,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_set(0,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_set(0,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, two parameters with changing parameters (both orbs) **/
+	for(i=0;i<256;i++){
+		orb_set(i,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_set(0,i,i);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_set(i,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, all parameters with changing parameters (both orbs) **/		
+	for(i=0;i<256;i++){
+		orb_set(i,i,i);
+		delay_ms(10);
+	}
+		
+/** Test RGB color setting (orb1) **/
+	for(i=0;i<256;i++){
+		orb1_set(i,0,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb1_set(0,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb1_set(0,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, two parameters with changing parameters (orb1) **/
+	for(i=0;i<256;i++){
+		orb1_set(i,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb1_set(0,i,i);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb1_set(i,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, all parameters with changing parameters (orb1) **/		
+	for(i=0;i<256;i++){
+		orb1_set(i,i,i);
+		delay_ms(10);
+	}
 
-    orb_set_color(RED);
+/** Test RGB color setting (orb2) **/
+	for(i=0;i<256;i++){
+		orb2_set(i,0,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb2_set(0,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb2_set(0,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, two parameters with changing parameters (orb2) **/
+	for(i=0;i<256;i++){
+		orb2_set(i,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb2_set(0,i,i);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb2_set(i,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, all parameters with changing parameters (orb2) **/		
+	for(i=0;i<256;i++){
+		orb2_set(i,i,i);
+		delay_ms(10);
+	}
+	
+/** Test RGB color setting (n=1) **/
+	for(i=0;i<256;i++){
+		orb_n_set(1,i,0,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(1,0,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(1,0,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, two parameters with two changing parameters (n=1) **/
+	for(i=0;i<256;i++){
+		orb_n_set(1,i,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(1,0,i,i);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(1,i,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, all parameters with two changing parameters (n=1) **/		
+	for(i=0;i<256;i++){
+		orb_n_set(1,i,i,i);
+		delay_ms(10);
+	}
+
+/** Test RGB color setting (n=2) **/
+	for(i=0;i<256;i++){
+		orb_n_set(2,i,0,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(2,0,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(2,0,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, two parameters with two changing parameters (n=2) **/
+	for(i=0;i<256;i++){
+		orb_n_set(2,i,i,0);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(2,0,i,i);
+		delay_ms(10);
+	}
+	for(i=0;i<256;i++){
+		orb_n_set(2,i,0,i);
+		delay_ms(10);
+	}
+		
+/** Test RBG color, all parameters with two changing parameters (n=2) **/		
+	for(i=0;i<256;i++){
+		orb_n_set(2,i,i,i);
+		delay_ms(10);
+	}
+
+/** Weird not even RGB color test for both orbs **/		
+	for(i=2;i<256;i++){
+		orbs_set (i,i-1,i-2,i-2,i-1,i);
+		delay_ms(10);
+	}
+
+/** Test all #define'd colors (both orbs) **/
+    orb_set_color(ORB_OFF);
     delay_ms(1000);
+	orb_set_color(RED);
+    delay_ms(1000);
     orb_set_color(ORANGE);
     delay_ms(1000);
     orb_set_color(YELLOW);
     delay_ms(1000);
+	orb_set_color(LIME);
+    delay_ms(1000);
     orb_set_color(GREEN);
     delay_ms(1000);
+	orb_set_color(CYAN);
+    delay_ms(1000);
     orb_set_color(BLUE);
     delay_ms(1000);
+	orb_set_color(PINK);
+    delay_ms(1000);
     orb_set_color(PURPLE);
     delay_ms(1000);
+	orb_set_color(MAGENTA);
+    delay_ms(1000);
+	orb_set_color(WHITE);
+    delay_ms(1000);
+	orb_set_color(ORB_OFF);
+    delay_ms(1000);
+	
+/** Test all #define'd colors (orb1) **/
+    orb1_set_color(ORB_OFF);
+    delay_ms(1000);
+	orb1_set_color(RED);
+    delay_ms(1000);
+    orb1_set_color(ORANGE);
+    delay_ms(1000);
+    orb1_set_color(YELLOW);
+    delay_ms(1000);
+	orb1_set_color(LIME);
+    delay_ms(1000);
+    orb1_set_color(GREEN);
+    delay_ms(1000);
+	orb1_set_color(CYAN);
+    delay_ms(1000);
+    orb1_set_color(BLUE);
+    delay_ms(1000);
+	orb1_set_color(PINK);
+    delay_ms(1000);
+    orb1_set_color(PURPLE);
+    delay_ms(1000);
+	orb1_set_color(MAGENTA);
+    delay_ms(1000);
+	orb1_set_color(WHITE);
+    delay_ms(1000);
+	orb1_set_color(ORB_OFF);
+    delay_ms(1000);
 
+/** Test all #define'd colors (orb2) **/
+    orb2_set_color(ORB_OFF);
+    delay_ms(1000);
+	orb2_set_color(RED);
+    delay_ms(1000);
+    orb2_set_color(ORANGE);
+    delay_ms(1000);
+    orb2_set_color(YELLOW);
+    delay_ms(1000);
+	orb2_set_color(LIME);
+    delay_ms(1000);
+    orb2_set_color(GREEN);
+    delay_ms(1000);
+	orb2_set_color(CYAN);
+    delay_ms(1000);
+    orb2_set_color(BLUE);
+    delay_ms(1000);
+	orb2_set_color(PINK);
+    delay_ms(1000);
+    orb2_set_color(PURPLE);
+    delay_ms(1000);
+	orb2_set_color(MAGENTA);
+    delay_ms(1000);
+	orb2_set_color(WHITE);
+    delay_ms(1000);
+	orb2_set_color(ORB_OFF);
+    delay_ms(1000);
+	
+/** Test all #define'd colors (n=1) **/
+    orb_n_set_color(1,ORB_OFF);
+    delay_ms(1000);
+	orb_n_set_color(1,RED);
+    delay_ms(1000);
+    orb_n_set_color(1,ORANGE);
+    delay_ms(1000);
+    orb_n_set_color(1,YELLOW);
+    delay_ms(1000);
+	orb_n_set_color(1,LIME);
+    delay_ms(1000);
+    orb_n_set_color(1,GREEN);
+    delay_ms(1000);
+	orb_n_set_color(1,CYAN);
+    delay_ms(1000);
+    orb_n_set_color(1,BLUE);
+    delay_ms(1000);
+	orb_n_set_color(1,PINK);
+    delay_ms(1000);
+    orb_n_set_color(1,PURPLE);
+    delay_ms(1000);
+	orb_n_set_color(1,MAGENTA);
+    delay_ms(1000);
+	orb_n_set_color(1,WHITE);
+    delay_ms(1000);
+	orb_n_set_color(1,ORB_OFF);
+    delay_ms(1000);
+	
+/** Test all #define'd colors (n=2) **/
+    orb_n_set_color(2,ORB_OFF);
+    delay_ms(1000);
+	orb_n_set_color(2,RED);
+    delay_ms(1000);
+    orb_n_set_color(2,ORANGE);
+    delay_ms(1000);
+    orb_n_set_color(2,YELLOW);
+    delay_ms(1000);
+	orb_n_set_color(2,LIME);
+    delay_ms(1000);
+    orb_n_set_color(2,GREEN);
+    delay_ms(1000);
+	orb_n_set_color(2,CYAN);
+    delay_ms(1000);
+    orb_n_set_color(2,BLUE);
+    delay_ms(1000);
+	orb_n_set_color(2,PINK);
+    delay_ms(1000);
+    orb_n_set_color(2,PURPLE);
+    delay_ms(1000);
+	orb_n_set_color(2,MAGENTA);
+    delay_ms(1000);
+	orb_n_set_color(2,WHITE);
+    delay_ms(1000);
+	orb_n_set_color(2,ORB_OFF);
+    delay_ms(1000);
+	
+	/** Test all #define'd colors (both orbs) **/
+    orbs_set_color(ORB_OFF,ORB_OFF);
+    delay_ms(1000);
+	orbs_set_color(RED,RED);
+    delay_ms(1000);
+    orbs_set_color(ORANGE,ORANGE);
+    delay_ms(1000);
+    orbs_set_color(YELLOW,YELLOW);
+    delay_ms(1000);
+	orbs_set_color(LIME,LIME);
+    delay_ms(1000);
+    orbs_set_color(GREEN,GREEN);
+    delay_ms(1000);
+	orbs_set_color(CYAN,CYAN);
+    delay_ms(1000);
+    orbs_set_color(BLUE,BLUE);
+    delay_ms(1000);
+	orbs_set_color(PINK,PINK);
+    delay_ms(1000);
+    orbs_set_color(PURPLE,PURPLE);
+    delay_ms(1000);
+	orbs_set_color(MAGENTA,MAGENTA);
+    delay_ms(1000);
+	orbs_set_color(WHITE,WHITE);
+    delay_ms(1000);
+	orbs_set_color(ORB_OFF,ORB_OFF);
+    delay_ms(1000);
+	
+	orbs_set_color(RED,GREEN);
+	delay_ms(3000);
+	
     return 0;
 }
 