Index: group__wlerror.html
===================================================================
--- group__wlerror.html	(revision 1424)
+++ group__wlerror.html	(revision 1425)
@@ -1,10 +1,13 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
-<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
 <title>libwireless: Error Packets</title>
-<link href="tabs.css" rel="stylesheet" type="text/css">
-<link href="doxygen.css" rel="stylesheet" type="text/css">
-</head><body>
-<!-- Generated by Doxygen 1.5.9 -->
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<link href="doxygen.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+<!-- Generated by Doxygen 1.6.1 -->
 <div class="navigation" id="top">
   <div class="tabs">
     <ul>
@@ -16,33 +19,30 @@
   </div>
 </div>
 <div class="contents">
-<h1>Error Packets</h1>Functions for sending and receiving error packets.  
-<a href="#_details">More...</a>
-<p>
+<h1>Error Packets</h1>
+<p>Functions for sending and receiving error packets.  
+<a href="#_details">More...</a></p>
 <table border="0" cellpadding="0" cellspacing="0">
-<tr><td></td></tr>
-<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wlerror.html#g3217351e71b892a90ed3ba79ed36e354">wl_error_register</a> (void)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Register this packet group with the wireless library.  <a href="#g3217351e71b892a90ed3ba79ed36e354"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wlerror.html#g4c737d93fefc9aa8d4f87c9296bfa8a0">wl_error_unregister</a> (void)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unregister this packet group with the wireless library.  <a href="#g4c737d93fefc9aa8d4f87c9296bfa8a0"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wlerror.html#g01c7382a758876fce52c18a3e6c81534">wl_error_send_string</a> (char *str)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a string in an error packet.  <a href="#g01c7382a758876fce52c18a3e6c81534"></a><br></td></tr>
+<tr><td colspan="2"><h2>Functions</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wlerror.html#ga3217351e71b892a90ed3ba79ed36e354">wl_error_register</a> (void)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Register this packet group with the wireless library.  <a href="#ga3217351e71b892a90ed3ba79ed36e354"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wlerror.html#ga4c737d93fefc9aa8d4f87c9296bfa8a0">wl_error_unregister</a> (void)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unregister this packet group with the wireless library.  <a href="#ga4c737d93fefc9aa8d4f87c9296bfa8a0"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wlerror.html#ga01c7382a758876fce52c18a3e6c81534">wl_error_send_string</a> (char *str)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a string in an error packet.  <a href="#ga01c7382a758876fce52c18a3e6c81534"></a><br/></td></tr>
 </table>
-<hr><a name="_details"></a><h2>Detailed Description</h2>
-Functions for sending and receiving error packets. <hr><h2>Function Documentation</h2>
-<a class="anchor" name="g3217351e71b892a90ed3ba79ed36e354"></a><!-- doxytag: member="wl_error_group.h::wl_error_register" ref="g3217351e71b892a90ed3ba79ed36e354" args="(void)" -->
+<hr/><a name="_details"></a><h2>Detailed Description</h2>
+<p>Functions for sending and receiving error packets. </p>
+<hr/><h2>Function Documentation</h2>
+<a class="anchor" id="ga3217351e71b892a90ed3ba79ed36e354"></a><!-- doxytag: member="wl_error_group.h::wl_error_register" ref="ga3217351e71b892a90ed3ba79ed36e354" args="(void)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_error_register           </td>
+          <td class="memname">void wl_error_register </td>
           <td>(</td>
           <td class="paramtype">void&nbsp;</td>
-          <td class="paramname">          </td>
+          <td class="paramname"></td>
           <td>&nbsp;)&nbsp;</td>
           <td></td>
         </tr>
@@ -50,23 +50,22 @@
 </div>
 <div class="memdoc">
 
-<p>
-Register this packet group with the wireless library. 
-<p>
-Register this packet group with the wireless library. This function must be called before any other wl_error function. 
+<p>Register this packet group with the wireless library. </p>
+<p>Register this packet group with the wireless library. This function must be called before any other wl_error function. </p>
+
 <p>References <a class="el" href="wireless_8c_source.html#l00342">wl_register_packet_group()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="g01c7382a758876fce52c18a3e6c81534"></a><!-- doxytag: member="wl_error_group.h::wl_error_send_string" ref="g01c7382a758876fce52c18a3e6c81534" args="(char *str)" -->
+</div>
+<a class="anchor" id="ga01c7382a758876fce52c18a3e6c81534"></a><!-- doxytag: member="wl_error_group.h::wl_error_send_string" ref="ga01c7382a758876fce52c18a3e6c81534" args="(char *str)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_error_send_string           </td>
+          <td class="memname">void wl_error_send_string </td>
           <td>(</td>
           <td class="paramtype">char *&nbsp;</td>
-          <td class="paramname"> <em>str</em>          </td>
+          <td class="paramname"> <em>str</em></td>
           <td>&nbsp;)&nbsp;</td>
           <td></td>
         </tr>
@@ -74,29 +73,28 @@
 </div>
 <div class="memdoc">
 
-<p>
-Send a string in an error packet. 
-<p>
-Send an error message as a string.<p>
-<dl compact><dt><b>Parameters:</b></dt><dd>
+<p>Send a string in an error packet. </p>
+<p>Send an error message as a string.</p>
+<dl><dt><b>Parameters:</b></dt><dd>
   <table border="0" cellspacing="2" cellpadding="0">
     <tr><td valign="top"></td><td valign="top"><em>str</em>&nbsp;</td><td>the error message to send </td></tr>
   </table>
+  </dd>
 </dl>
 
 <p>References <a class="el" href="wireless_8c_source.html#l00285">wl_send_global_packet()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="g4c737d93fefc9aa8d4f87c9296bfa8a0"></a><!-- doxytag: member="wl_error_group.h::wl_error_unregister" ref="g4c737d93fefc9aa8d4f87c9296bfa8a0" args="(void)" -->
+</div>
+<a class="anchor" id="ga4c737d93fefc9aa8d4f87c9296bfa8a0"></a><!-- doxytag: member="wl_error_group.h::wl_error_unregister" ref="ga4c737d93fefc9aa8d4f87c9296bfa8a0" args="(void)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_error_unregister           </td>
+          <td class="memname">void wl_error_unregister </td>
           <td>(</td>
           <td class="paramtype">void&nbsp;</td>
-          <td class="paramname">          </td>
+          <td class="paramname"></td>
           <td>&nbsp;)&nbsp;</td>
           <td></td>
         </tr>
@@ -104,19 +102,17 @@
 </div>
 <div class="memdoc">
 
-<p>
-Unregister this packet group with the wireless library. 
-<p>
-Unregister this packet group with the wireless library. This function must be called after wl_error_register.<p>
-<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wlerror.html#g3217351e71b892a90ed3ba79ed36e354" title="Register this packet group with the wireless library.">wl_error_register</a> </dd></dl>
+<p>Unregister this packet group with the wireless library. </p>
+<p>Unregister this packet group with the wireless library. This function must be called after wl_error_register.</p>
+<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="group__wlerror.html#ga3217351e71b892a90ed3ba79ed36e354" title="Register this packet group with the wireless library.">wl_error_register</a> </dd></dl>
 
 <p>References <a class="el" href="wireless_8c_source.html#l00362">wl_unregister_packet_group()</a>.</p>
 
 </div>
-</div><p>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 8 19:59:17 2009 for libwireless by&nbsp;
+</div>
+<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 20 12:12:02 2009 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
+<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
 </body>
 </html>