Index: structPacketGroupHandler.html
===================================================================
--- structPacketGroupHandler.html	(revision 1424)
+++ structPacketGroupHandler.html	(revision 1425)
@@ -1,10 +1,13 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
-<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
 <title>libwireless: PacketGroupHandler Struct Reference</title>
-<link href="tabs.css" rel="stylesheet" type="text/css">
-<link href="doxygen.css" rel="stylesheet" type="text/css">
-</head><body>
-<!-- Generated by Doxygen 1.5.9 -->
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<link href="doxygen.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+<!-- Generated by Doxygen 1.6.1 -->
 <div class="navigation" id="top">
   <div class="tabs">
     <ul>
@@ -22,58 +25,50 @@
   </div>
 </div>
 <div class="contents">
-<h1>PacketGroupHandler Struct Reference<br>
+<h1>PacketGroupHandler Struct Reference<br/>
 <small>
 [<a class="el" href="group__wireless.html">Wireless</a>]</small>
-</h1><!-- doxytag: class="PacketGroupHandler" --><code>#include &lt;<a class="el" href="wireless_8h_source.html">wireless.h</a>&gt;</code>
-<p>
+</h1><!-- doxytag: class="PacketGroupHandler" -->
+<p><code>#include &lt;<a class="el" href="wireless_8h_source.html">wireless.h</a>&gt;</code></p>
 <table border="0" cellpadding="0" cellspacing="0">
-<tr><td></td></tr>
-<tr><td colspan="2"><br><h2>Data Fields</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#f0849c643f1b1e257ccfe96110109950">groupCode</a></td></tr>
-
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#952b4b63982db13f55c02e17c55ab5ac">timeout_handler</a> )(void)</td></tr>
-
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#045939030c6e2f2dd0d53b5718d9f902">handle_response</a> )(int frame, int received)</td></tr>
-
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#5c01636d72de2ddafc734ab754d93104">handle_receive</a> )(char type, int source, unsigned char *packet, int length)</td></tr>
-
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#c03247d5c07e97e35b1f557c0937b0eb">unregister</a> )(void)</td></tr>
-
+<tr><td colspan="2"><h2>Data Fields</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#af0849c643f1b1e257ccfe96110109950">groupCode</a></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#a952b4b63982db13f55c02e17c55ab5ac">timeout_handler</a> )(void)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#a045939030c6e2f2dd0d53b5718d9f902">handle_response</a> )(int frame, int received)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#a5c01636d72de2ddafc734ab754d93104">handle_receive</a> )(char type, int source, unsigned char *packet, int length)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html#ac03247d5c07e97e35b1f557c0937b0eb">unregister</a> )(void)</td></tr>
 </table>
-<hr><a name="_details"></a><h2>Detailed Description</h2>
-A <a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> represents a packet group, and is used to register a packet group with the wireless library. It contains handlers for various events which can occur related to a packet group. <hr><h2>Field Documentation</h2>
-<a class="anchor" name="f0849c643f1b1e257ccfe96110109950"></a><!-- doxytag: member="PacketGroupHandler::groupCode" ref="f0849c643f1b1e257ccfe96110109950" args="" -->
+<hr/><a name="_details"></a><h2>Detailed Description</h2>
+<p>A <a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> represents a packet group, and is used to register a packet group with the wireless library. It contains handlers for various events which can occur related to a packet group. </p>
+<hr/><h2>Field Documentation</h2>
+<a class="anchor" id="af0849c643f1b1e257ccfe96110109950"></a><!-- doxytag: member="PacketGroupHandler::groupCode" ref="af0849c643f1b1e257ccfe96110109950" args="" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">unsigned int <a class="el" href="structPacketGroupHandler.html#f0849c643f1b1e257ccfe96110109950">PacketGroupHandler::groupCode</a>          </td>
+          <td class="memname">unsigned int <a class="el" href="structPacketGroupHandler.html#af0849c643f1b1e257ccfe96110109950">PacketGroupHandler::groupCode</a></td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
+<p>The group code for this packet group. This number must be unique. The maximum number of packet groups is defined by WL_MAX_PACKET_GROUPS. </p>
 
-<p>
-The group code for this packet group. This number must be unique. The maximum number of packet groups is defined by WL_MAX_PACKET_GROUPS. 
 <p>Referenced by <a class="el" href="wl__basic_8c_source.html#l00042">wl_basic_register_handler()</a>, <a class="el" href="wireless_8c_source.html#l00342">wl_register_packet_group()</a>, and <a class="el" href="wireless_8c_source.html#l00362">wl_unregister_packet_group()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="5c01636d72de2ddafc734ab754d93104"></a><!-- doxytag: member="PacketGroupHandler::handle_receive" ref="5c01636d72de2ddafc734ab754d93104" args=")(char type, int source, unsigned char *packet, int length)" -->
+</div>
+<a class="anchor" id="a5c01636d72de2ddafc734ab754d93104"></a><!-- doxytag: member="PacketGroupHandler::handle_receive" ref="a5c01636d72de2ddafc734ab754d93104" args=")(char type, int source, unsigned char *packet, int length)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#5c01636d72de2ddafc734ab754d93104">PacketGroupHandler::handle_receive</a>)(char type, int source, unsigned char *packet, int length)          </td>
+          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#a5c01636d72de2ddafc734ab754d93104">PacketGroupHandler::handle_receive</a>)(char type, int source, unsigned char *packet, int length)</td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
-
-<p>
-Called when we receive a packet from this group.<p>
-<dl compact><dt><b>Parameters:</b></dt><dd>
+<p>Called when we receive a packet from this group.</p>
+<dl><dt><b>Parameters:</b></dt><dd>
   <table border="0" cellspacing="2" cellpadding="0">
     <tr><td valign="top"></td><td valign="top"><em>type</em>&nbsp;</td><td>the packet type </td></tr>
     <tr><td valign="top"></td><td valign="top"><em>source</em>&nbsp;</td><td>the 16-bit address of the XBee this packet was sent from </td></tr>
@@ -80,75 +75,74 @@
     <tr><td valign="top"></td><td valign="top"><em>packet</em>&nbsp;</td><td>the packet received </td></tr>
     <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>the length of the packet </td></tr>
   </table>
+  </dd>
 </dl>
 
 <p>Referenced by <a class="el" href="wl__basic_8c_source.html#l00042">wl_basic_register_handler()</a>, and <a class="el" href="wireless_8c_source.html#l00390">wl_do()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="045939030c6e2f2dd0d53b5718d9f902"></a><!-- doxytag: member="PacketGroupHandler::handle_response" ref="045939030c6e2f2dd0d53b5718d9f902" args=")(int frame, int received)" -->
+</div>
+<a class="anchor" id="a045939030c6e2f2dd0d53b5718d9f902"></a><!-- doxytag: member="PacketGroupHandler::handle_response" ref="a045939030c6e2f2dd0d53b5718d9f902" args=")(int frame, int received)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#045939030c6e2f2dd0d53b5718d9f902">PacketGroupHandler::handle_response</a>)(int frame, int received)          </td>
+          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#a045939030c6e2f2dd0d53b5718d9f902">PacketGroupHandler::handle_response</a>)(int frame, int received)</td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
-
-<p>
-Called when a transmit status packet is received from the XBee where the first four bits of the frame are the group code.<p>
-<dl compact><dt><b>Parameters:</b></dt><dd>
+<p>Called when a transmit status packet is received from the XBee where the first four bits of the frame are the group code.</p>
+<dl><dt><b>Parameters:</b></dt><dd>
   <table border="0" cellspacing="2" cellpadding="0">
     <tr><td valign="top"></td><td valign="top"><em>frame</em>&nbsp;</td><td>the last four bits of the frame </td></tr>
     <tr><td valign="top"></td><td valign="top"><em>received</em>&nbsp;</td><td>is true if we received an ack, 0 if we did not. </td></tr>
   </table>
+  </dd>
 </dl>
 
 <p>Referenced by <a class="el" href="wl__basic_8c_source.html#l00042">wl_basic_register_handler()</a>, and <a class="el" href="wireless_8c_source.html#l00390">wl_do()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="952b4b63982db13f55c02e17c55ab5ac"></a><!-- doxytag: member="PacketGroupHandler::timeout_handler" ref="952b4b63982db13f55c02e17c55ab5ac" args=")(void)" -->
+</div>
+<a class="anchor" id="a952b4b63982db13f55c02e17c55ab5ac"></a><!-- doxytag: member="PacketGroupHandler::timeout_handler" ref="a952b4b63982db13f55c02e17c55ab5ac" args=")(void)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#952b4b63982db13f55c02e17c55ab5ac">PacketGroupHandler::timeout_handler</a>)(void)          </td>
+          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#a952b4b63982db13f55c02e17c55ab5ac">PacketGroupHandler::timeout_handler</a>)(void)</td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
+<p>Called every half second (not in interrupt, but in wl_do). </p>
 
-<p>
-Called every half second (not in interrupt, but in wl_do). 
 <p>Referenced by <a class="el" href="wl__basic_8c_source.html#l00042">wl_basic_register_handler()</a>.</p>
 
 </div>
-</div><p>
-<a class="anchor" name="c03247d5c07e97e35b1f557c0937b0eb"></a><!-- doxytag: member="PacketGroupHandler::unregister" ref="c03247d5c07e97e35b1f557c0937b0eb" args=")(void)" -->
+</div>
+<a class="anchor" id="ac03247d5c07e97e35b1f557c0937b0eb"></a><!-- doxytag: member="PacketGroupHandler::unregister" ref="ac03247d5c07e97e35b1f557c0937b0eb" args=")(void)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#c03247d5c07e97e35b1f557c0937b0eb">PacketGroupHandler::unregister</a>)(void)          </td>
+          <td class="memname">void(* <a class="el" href="structPacketGroupHandler.html#ac03247d5c07e97e35b1f557c0937b0eb">PacketGroupHandler::unregister</a>)(void)</td>
         </tr>
       </table>
 </div>
 <div class="memdoc">
+<p>Called for any cleanup when the network is turned off. </p>
 
-<p>
-Called for any cleanup when the network is turned off. 
 <p>Referenced by <a class="el" href="wl__basic_8c_source.html#l00042">wl_basic_register_handler()</a>, <a class="el" href="wireless_8c_source.html#l00159">wl_terminate()</a>, and <a class="el" href="wireless_8c_source.html#l00362">wl_unregister_packet_group()</a>.</p>
 
 </div>
-</div><p>
-<hr>The documentation for this struct was generated from the following file:<ul>
-<li><a class="el" href="wireless_8h_source.html">wireless.h</a></ul>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 8 19:59:17 2009 for libwireless by&nbsp;
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="wireless_8h_source.html">wireless.h</a></li>
+</ul>
+</div>
+<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 20 12:12:02 2009 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
+<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
 </body>
 </html>